diff -Nur --exclude=.svn src/backends/empty/Makefile.am soci/backends/empty/Makefile.am
--- src/backends/empty/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/empty/Makefile.am	2009-04-19 01:26:43.000000000 +0200
@@ -1,37 +1,28 @@
-# $Id: Makefile.am,v 1.5 2008/04/28 19:58:54 mloskot Exp $
-# 
-# Copyright (C) 2006, Mateusz Loskot
-#
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-INCLUDES = -I$(top_srcdir)/src/core
-AM_CXXFLAGS = -fPIC
-
-noinst_LTLIBRARIES	= \
-	lib@SOCI_EMPTY_LIBRARY_NAME@.la
-
-lib@SOCI_EMPTY_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined
-
-lib@SOCI_EMPTY_LIBRARY_NAME@_la_SOURCES = \
-	blob.cpp \
-	factory.cpp \
-	row-id.cpp \
-	session.cpp \
-	standard-into-type.cpp \
-	standard-use-type.cpp \
-	statement.cpp \
-	vector-into-type.cpp \
-	vector-use-type.cpp
-
-soci_emptydir = $(includedir)/soci/empty
-
-soci_empty_HEADERS = \
-	soci-empty.h
-
-EXTRA_DIST = Makefile.basic
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## backends/empty sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+lib_LTLIBRARIES= libsoci_empty.la
+
+libsoci_empty_la_SOURCES= $(bck_empty_h_sources) $(bck_empty_cc_sources) 
+libsoci_empty_la_CXXFLAGS = $(EMPTY_CFLAGS)
+libsoci_empty_la_LIBADD =
+libsoci_empty_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+pkginclude_HEADERS = $(bck_empty_h_sources) 
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/backends/empty
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/backends/empty/soci-empty.h soci/backends/empty/soci-empty.h
--- src/backends/empty/soci-empty.h	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/empty/soci-empty.h	2009-04-05 17:04:54.000000000 +0200
@@ -22,8 +22,12 @@
 #ifndef SOCI_EMPTY_DECL
 # define SOCI_EMPTY_DECL
 #endif
-
-#include "soci-backend.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
 
 namespace soci
 {
diff -Nur --exclude=.svn src/backends/empty/sources.mk soci/backends/empty/sources.mk
--- src/backends/empty/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/empty/sources.mk	2009-03-28 15:22:29.000000000 +0100
@@ -0,0 +1,12 @@
+bck_empty_h_sources = \
+        $(top_srcdir)/soci/backends/empty/soci-empty.h
+bck_empty_cc_sources = \
+        $(top_srcdir)/soci/backends/empty/blob.cpp \
+        $(top_srcdir)/soci/backends/empty/factory.cpp \
+        $(top_srcdir)/soci/backends/empty/row-id.cpp \
+        $(top_srcdir)/soci/backends/empty/session.cpp \
+        $(top_srcdir)/soci/backends/empty/standard-into-type.cpp \
+        $(top_srcdir)/soci/backends/empty/standard-use-type.cpp \
+        $(top_srcdir)/soci/backends/empty/statement.cpp \
+        $(top_srcdir)/soci/backends/empty/vector-into-type.cpp \
+        $(top_srcdir)/soci/backends/empty/vector-use-type.cpp
diff -Nur --exclude=.svn src/backends/empty/test/Makefile.am soci/backends/empty/test/Makefile.am
--- src/backends/empty/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/empty/test/Makefile.am	2009-04-19 01:42:54.000000000 +0200
@@ -1,31 +1,21 @@
-# $Id: Makefile.am,v 1.6 2008/05/12 10:56:32 mloskot Exp $
-# 
-# Copyright (C) 2006, Mateusz Loskot
-#
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = $(BOOST_CPPFLAGS)
+## backends/empty/test sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
 
-INCLUDES = \
-	-I$(top_srcdir)/src/core \
-	-I$(top_srcdir)/src/backends/empty
+MAINTAINERCLEANFILES = Makefile.in
 
-noinst_PROGRAMS = \
-	test_empty
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
 
-test_empty_SOURCES = \
-	test-empty.cpp
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
 
-test_empty_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/empty/lib@SOCI_EMPTY_LIBRARY_NAME@.la
+if RUN_TESTS
+  noinst_PROGRAMS = test_empty
+endif
 
-EXTRA_DIST = Makefile.basic
+test_empty_SOURCES = $(empty_test_cc_sources)
+test_empty_CXXFLAGS =
+test_empty_LDADD =
+test_empty_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/empty/libsoci_empty.la
 
-check-local: test_empty
-	./test_empty dummystr
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+#nodist_pkginclude_HEADERS = $(empty_test_h_sources)
diff -Nur --exclude=.svn src/backends/empty/test/sources.mk soci/backends/empty/test/sources.mk
--- src/backends/empty/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/empty/test/sources.mk	2009-03-28 15:22:29.000000000 +0100
@@ -0,0 +1,2 @@
+empty_test_h_sources =
+empty_test_cc_sources = $(top_srcdir)/soci/backends/empty/test/test-empty.cpp
diff -Nur --exclude=.svn src/backends/empty/test/test-empty.cpp soci/backends/empty/test/test-empty.cpp
--- src/backends/empty/test/test-empty.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/empty/test/test-empty.cpp	2009-04-05 17:30:35.000000000 +0200
@@ -5,8 +5,15 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 //
 
-#include "soci.h"
-#include "soci-empty.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci.h>
+#       include <soci/backends/empty/soci-empty.h>
+#else
+#	include <soci.h>
+#	include <soci-empty.h>
+#endif
+//
 #include <iostream>
 #include <string>
 #include <cassert>
diff -Nur --exclude=.svn src/backends/firebird/Makefile.am soci/backends/firebird/Makefile.am
--- src/backends/firebird/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/firebird/Makefile.am	2009-04-19 01:57:38.000000000 +0200
@@ -1,43 +1,31 @@
-# $Id: Makefile.am,v 1.5 2008/05/13 11:59:34 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-INCLUDES = -I$(top_srcdir)/src/core
-AM_CXXFLAGS = -fPIC
-AM_CPPFLAGS = @FIREBIRD_CFLAGS@
-
-lib_LTLIBRARIES	= \
-	lib@SOCI_FIREBIRD_LIBRARY_NAME@.la
-
-lib@SOCI_FIREBIRD_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined @FIREBIRD_LDFLAGS@
-
-lib@SOCI_FIREBIRD_LIBRARY_NAME@_la_LIBADD = \
-	@top_builddir@/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la
-
-lib@SOCI_FIREBIRD_LIBRARY_NAME@_la_SOURCES = \
-	blob.cpp \
-	common.cpp \
-	error-firebird.cpp \
-	factory.cpp \
-	row-id.cpp \
-	session.cpp \
-	standard-into-type.cpp \
-	standard-use-type.cpp \
-	statement.cpp \
-	vector-into-type.cpp \
-	vector-use-type.cpp
-
-soci_firebirddir = $(includedir)/soci/firebird
-
-soci_firebird_HEADERS = \
-	common.h \
-	error-firebird.h \
-	soci-firebird.h
-
-EXTRA_DIST = Makefile.basic
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## backends/firebird sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+#EXTRA_DIST_FOR_SOCI_COMPATIBILITY = ._common.h
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+if HAVE_FIREBIRD
+lib_LTLIBRARIES= libsoci_firebird.la
+
+libsoci_firebird_la_SOURCES= $(bck_firebird_h_sources) $(bck_firebird_cc_sources) 
+libsoci_firebird_la_CXXFLAGS = $(FIREBIRD_CFLAGS)
+libsoci_firebird_la_LIBADD =
+libsoci_firebird_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+pkginclude_HEADERS = $(top_srcdir)/soci/backends/firebird/soci-firebird.h
+endif
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/backends/firebird
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/backends/firebird/sources.mk soci/backends/firebird/sources.mk
--- src/backends/firebird/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/firebird/sources.mk	2009-04-19 01:39:10.000000000 +0200
@@ -0,0 +1,16 @@
+bck_firebird_h_sources = \
+        $(top_srcdir)/soci/backends/firebird/common.h \
+        $(top_srcdir)/soci/backends/firebird/error-firebird.h \
+        $(top_srcdir)/soci/backends/firebird/soci-firebird.h
+bck_firebird_cc_sources = \
+        $(top_srcdir)/soci/backends/firebird/blob.cpp \
+        $(top_srcdir)/soci/backends/firebird/common.cpp \
+        $(top_srcdir)/soci/backends/firebird/error-firebird.cpp \
+        $(top_srcdir)/soci/backends/firebird/factory.cpp \
+        $(top_srcdir)/soci/backends/firebird/row-id.cpp \
+        $(top_srcdir)/soci/backends/firebird/session.cpp \
+        $(top_srcdir)/soci/backends/firebird/standard-into-type.cpp \
+        $(top_srcdir)/soci/backends/firebird/standard-use-type.cpp \
+        $(top_srcdir)/soci/backends/firebird/statement.cpp \
+        $(top_srcdir)/soci/backends/firebird/vector-into-type.cpp \
+        $(top_srcdir)/soci/backends/firebird/vector-use-type.cpp
diff -Nur --exclude=.svn src/backends/firebird/test/Makefile.am soci/backends/firebird/test/Makefile.am
--- src/backends/firebird/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/firebird/test/Makefile.am	2009-04-19 01:55:58.000000000 +0200
@@ -1,28 +1,22 @@
-# $Id: Makefile.am,v 1.6 2008/04/28 19:58:54 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = @BOOST_CPPFLAGS@ @FIREBIRD_CFLAGS@
-AM_LDFLAGS = @FIREBIRD_LDFLAGS@
-
-INCLUDES = \
-	-I$(top_srcdir)/src/core \
-	-I$(top_srcdir)/src/core/test \
-	-I$(top_srcdir)/src/backends/firebird
-
-noinst_PROGRAMS = \
-	test_firebird
-
-test_firebird_SOURCES = \
-	test-firebird.cpp
-
-test_firebird_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/firebird/lib@SOCI_FIREBIRD_LIBRARY_NAME@.la
+## backends/firebird/test sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
 
-EXTRA_DIST = Makefile.basic
+MAINTAINERCLEANFILES = Makefile.in
 
-MAINTAINERCLEANLOCAL = Makefile.in
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
 
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+if RUN_TESTS
+  noinst_PROGRAMS = test_firebird
+endif
+
+test_firebird_SOURCES = $(firebird_test_cc_sources)
+test_firebird_CXXFLAGS = $(BOOST_CFLAGS)
+test_firebird_LDADD =
+test_firebird_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/firebird/libsoci_firebird.la \
+		$(FIREBIRD_LDFLAGS)
+
+#nodist_pkginclude_HEADERS = $(firebird_test_h_sources)
diff -Nur --exclude=.svn src/backends/firebird/test/sources.mk soci/backends/firebird/test/sources.mk
--- src/backends/firebird/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/firebird/test/sources.mk	2009-04-19 01:41:43.000000000 +0200
@@ -0,0 +1,2 @@
+firebird_test_h_sources =
+firebird_test_cc_sources = $(top_srcdir)/soci/backends/firebird/test/test-firebird.cpp
diff -Nur --exclude=.svn src/backends/Makefile.am soci/backends/Makefile.am
--- src/backends/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/Makefile.am	2009-04-10 01:16:41.000000000 +0200
@@ -1,13 +1,10 @@
-# $Id: Makefile.am,v 1.2 2006/11/27 09:59:31 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
+include $(top_srcdir)/Makefile.common
 
-SUBDIRS = \
-	@EMPTY_DIRS@ \
-	@FIREBIRD_DIRS@ \
-	@MYSQL_DIRS@  \
-	@ODBC_DIRS@  \
-	@ORACLE_DIRS@  \
-	@POSTGRESQL_DIRS@  \
-	@SQLITE3_DIRS@
+## Source directory
+
+MAINTAINERCLEANFILES = Makefile.in
+
+SUBDIRS = @EMPTY_DIRS@ @FIREBIRD_DIRS@ @MYSQL_DIRS@ \
+        @ODBC_DIRS@ @ORACLE_DIRS@ @POSTGRESQL_DIRS@ @SQLITE3_DIRS@
+
+EXTRA_DIST =
diff -Nur --exclude=.svn src/backends/mysql/common.cpp soci/backends/mysql/common.cpp
--- src/backends/mysql/common.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/common.cpp	2009-04-19 15:39:26.000000000 +0200
@@ -6,7 +6,13 @@
 //
 
 #include "common.h"
-#include "soci-backend.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
+//
 #include <ciso646>
 #include <cstdlib>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/mysql/common.h soci/backends/mysql/common.h
--- src/backends/mysql/common.h	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/common.h	2009-04-19 15:41:33.000000000 +0200
@@ -10,7 +10,6 @@
 
 #include "soci-mysql.h"
 // std
-#include <cstddef>
 #include <ctime>
 #include <sstream>
 #include <vector>
diff -Nur --exclude=.svn src/backends/mysql/Makefile.am soci/backends/mysql/Makefile.am
--- src/backends/mysql/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/Makefile.am	2009-04-19 01:30:54.000000000 +0200
@@ -1,41 +1,30 @@
-# $Id: Makefile.am,v 1.4 2008/04/28 19:58:54 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-INCLUDES = -I$(top_srcdir)/src/core
-AM_CXXFLAGS = -fPIC
-AM_CPPFLAGS = @MYSQL_CFLAGS@
-
-lib_LTLIBRARIES	= \
-	lib@SOCI_MYSQL_LIBRARY_NAME@.la
-
-lib@SOCI_MYSQL_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined @MYSQL_LDFLAGS@
-
-lib@SOCI_MYSQL_LIBRARY_NAME@_la_LIBADD = \
-	@top_builddir@/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la
-
-lib@SOCI_MYSQL_LIBRARY_NAME@_la_SOURCES = \
-	blob.cpp \
-	common.cpp \
-	factory.cpp \
-	row-id.cpp \
-	session.cpp \
-	standard-into-type.cpp \
-	standard-use-type.cpp \
-	statement.cpp \
-	vector-into-type.cpp \
-	vector-use-type.cpp
-
-soci_mysqldir = $(includedir)/soci/mysql
-
-soci_mysql_HEADERS = \
-	common.h \
-	soci-mysql.h
-
-EXTRA_DIST = Makefile.basic
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## backends/mysql sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+if HAVE_MYSQL
+lib_LTLIBRARIES= libsoci_mysql.la
+
+libsoci_mysql_la_SOURCES= $(bck_mysql_h_sources) $(bck_mysql_cc_sources) 
+libsoci_mysql_la_CXXFLAGS = $(MYSQL_CFLAGS)
+libsoci_mysql_la_LIBADD =
+libsoci_mysql_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+pkginclude_HEADERS = $(top_srcdir)/soci/backends/mysql/soci-mysql.h
+endif
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/backends/mysql
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/backends/mysql/session.cpp soci/backends/mysql/session.cpp
--- src/backends/mysql/session.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/session.cpp	2009-04-19 15:46:52.000000000 +0200
@@ -22,7 +22,6 @@
 
 using namespace soci;
 using namespace soci::details;
-using std::string;
 
 
 namespace
@@ -71,10 +70,10 @@
     return val;
 }
 
-string param_value(string::const_iterator *i,
-    string::const_iterator const & end)
+std::string param_value(std::string::const_iterator *i,
+    std::string::const_iterator const & end)
 {
-    string err = "Malformed connection string.";
+    std::string err = "Malformed connection string.";
     bool quot;
     if (**i == '\'')
     {
@@ -85,7 +84,7 @@
     {
         quot = false;
     }
-    string val("");
+    std::string val("");
     for (;;)
     {
         if (*i == end)
@@ -129,7 +128,7 @@
     return val;
 }
 
-bool valid_int(const string & s)
+bool valid_int(const std::string & s)
 {
     char *tail;
     const char *cstr = s.c_str();
@@ -146,12 +145,12 @@
     return true;
 }
 
-void parse_connect_string(const string & connectString,
-    string *host, bool *host_p,
-    string *user, bool *user_p,
-    string *password, bool *password_p,
-    string *db, bool *db_p,
-    string *unix_socket, bool *unix_socket_p,
+void parse_connect_string(const std::string & connectString,
+    std::string *host, bool *host_p,
+    std::string *user, bool *user_p,
+    std::string *password, bool *password_p,
+    std::string *db, bool *db_p,
+    std::string *unix_socket, bool *unix_socket_p,
     int *port, bool *port_p)
 {
     *host_p = false;
@@ -160,8 +159,8 @@
     *db_p = false;
     *unix_socket_p = false;
     *port_p = false;
-    string err = "Malformed connection string.";
-    string::const_iterator i = connectString.begin(),
+    std::string err = "Malformed connection string.";
+    std::string::const_iterator i = connectString.begin(),
         end = connectString.end();
     while (i != end)
     {
@@ -170,7 +169,7 @@
         {
             return;
         }
-        string par = param_name(&i, end);
+        std::string par = param_name(&i, end);
         skip_white(&i, end, false);
         if (*i == '=')
         {
@@ -181,7 +180,7 @@
             throw soci_error(err);
         }
         skip_white(&i, end, false);
-        string val = param_value(&i, end);
+        std::string val = param_value(&i, end);
         if (par == "port" and not *port_p)
         {
             if (not valid_int(val))
@@ -232,7 +231,7 @@
 mysql_session_backend::mysql_session_backend(
     std::string const & connectString)
 {
-    string host, user, password, db, unix_socket;
+    std::string host, user, password, db, unix_socket;
     int port;
     bool host_p, user_p, password_p, db_p, unix_socket_p, port_p;
     parse_connect_string(connectString, &host, &host_p, &user, &user_p,
@@ -250,9 +249,9 @@
             db_p ? db.c_str() : NULL,
             port_p ? port : 0,
             unix_socket_p ? unix_socket.c_str() : NULL,
-            CLIENT_MULTI_RESULTS) == NULL)
+            0) == NULL)
     {
-        string errMsg = mysql_error(conn_);
+        std::string errMsg = mysql_error(conn_);
         unsigned int errNum = mysql_errno(conn_);
         clean_up();
         throw mysql_soci_error(errMsg, errNum);
@@ -268,7 +267,7 @@
 {
 
 // helper function for hardcoded queries
-void hard_exec(MYSQL *conn, const string & query)
+void hard_exec(MYSQL *conn, const std::string & query)
 {
     if (0 != mysql_real_query(conn, query.c_str(),
             static_cast<unsigned long>(query.size())))
diff -Nur --exclude=.svn src/backends/mysql/soci-mysql.h soci/backends/mysql/soci-mysql.h
--- src/backends/mysql/soci-mysql.h	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/soci-mysql.h	2009-04-19 15:48:27.000000000 +0200
@@ -23,12 +23,23 @@
 #ifndef SOCI_MYSQL_DECL
 # define SOCI_MYSQL_DECL
 #endif
-
-#include "soci-backend.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
+//
 #ifdef _WIN32
 #include <winsock.h> // SOCKET
 #endif // _WIN32
-#include <mysql.h> // MySQL Client
+//
+// MySQL Client
+#if defined(SOCI_MYSQL_HEADERS_BURIED)
+#       include <mysql/mysql.h>
+#else
+#	include <mysql.h>
+#endif
 #include <vector>
 
 
diff -Nur --exclude=.svn src/backends/mysql/sources.mk soci/backends/mysql/sources.mk
--- src/backends/mysql/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/mysql/sources.mk	2009-03-28 15:22:27.000000000 +0100
@@ -0,0 +1,14 @@
+bck_mysql_h_sources = \
+        $(top_srcdir)/soci/backends/mysql/common.h \
+        $(top_srcdir)/soci/backends/mysql/soci-mysql.h
+bck_mysql_cc_sources = \
+        $(top_srcdir)/soci/backends/mysql/blob.cpp \
+        $(top_srcdir)/soci/backends/mysql/common.cpp \
+        $(top_srcdir)/soci/backends/mysql/factory.cpp \
+        $(top_srcdir)/soci/backends/mysql/row-id.cpp \
+        $(top_srcdir)/soci/backends/mysql/session.cpp \
+        $(top_srcdir)/soci/backends/mysql/standard-into-type.cpp \
+        $(top_srcdir)/soci/backends/mysql/standard-use-type.cpp \
+        $(top_srcdir)/soci/backends/mysql/statement.cpp \
+        $(top_srcdir)/soci/backends/mysql/vector-into-type.cpp \
+        $(top_srcdir)/soci/backends/mysql/vector-use-type.cpp
diff -Nur --exclude=.svn src/backends/mysql/standard-into-type.cpp soci/backends/mysql/standard-into-type.cpp
--- src/backends/mysql/standard-into-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/standard-into-type.cpp	2009-04-19 15:52:23.000000000 +0200
@@ -8,8 +8,14 @@
 
 #define SOCI_MYSQL_SOURCE
 #include "soci-mysql.h"
-#include <soci-platform.h>
 #include "common.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-platform.h>
+#else
+#	include <soci-platform.h>
+#endif
+//
 // std
 #include <ciso646>
 #include <cassert>
diff -Nur --exclude=.svn src/backends/mysql/standard-use-type.cpp soci/backends/mysql/standard-use-type.cpp
--- src/backends/mysql/standard-use-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/standard-use-type.cpp	2009-04-19 15:53:36.000000000 +0200
@@ -9,7 +9,13 @@
 #define SOCI_MYSQL_SOURCE
 #include "soci-mysql.h"
 #include "common.h"
-#include <soci-platform.h>
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-platform.h>
+#else
+#	include <soci-platform.h>
+#endif
+//
 #include <ciso646>
 #include <limits>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/mysql/test/Makefile.am soci/backends/mysql/test/Makefile.am
--- src/backends/mysql/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/test/Makefile.am	2009-04-19 01:31:02.000000000 +0200
@@ -1,27 +1,22 @@
-# $Id: Makefile.am,v 1.5 2008/04/28 19:58:54 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = @BOOST_CPPFLAGS@ @MYSQL_CFLAGS@
-AM_LDFLAGS = @MYSQL_LDFLAGS@
+## backend/mysql/test sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
 
-INCLUDES = \
-	-I$(top_srcdir)/src/core \
-	-I$(top_srcdir)/src/backends/mysql
+MAINTAINERCLEANFILES = Makefile.in
 
-noinst_PROGRAMS = \
-	test_mysql
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
 
-test_mysql_SOURCES = \
-	test-mysql.cpp
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
 
-test_mysql_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/mysql/lib@SOCI_MYSQL_LIBRARY_NAME@.la
+if RUN_TESTS
+  noinst_PROGRAMS = test_mysql
+endif
 
-EXTRA_DIST = Makefile.basic
+test_mysql_SOURCES = $(mysql_test_cc_sources)
+test_mysql_CXXFLAGS = $(BOOST_CFLAGS)
+test_mysql_LDADD =
+test_mysql_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/mysql/libsoci_mysql.la \
+		$(MYSQL_LDFLAGS)
 
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+#nodist_pkginclude_HEADERS = $(mysql_test_h_sources)
diff -Nur --exclude=.svn src/backends/mysql/test/sources.mk soci/backends/mysql/test/sources.mk
--- src/backends/mysql/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/mysql/test/sources.mk	2009-03-28 15:22:26.000000000 +0100
@@ -0,0 +1,2 @@
+mysql_test_h_sources =
+mysql_test_cc_sources = $(top_srcdir)/soci/backends/mysql/test/test-mysql.cpp
diff -Nur --exclude=.svn src/backends/mysql/test/test-mysql.cpp soci/backends/mysql/test/test-mysql.cpp
--- src/backends/mysql/test/test-mysql.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/test/test-mysql.cpp	2009-04-19 15:58:07.000000000 +0200
@@ -6,9 +6,17 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 //
 
-#include "soci.h"
-#include "soci-mysql.h"
-#include "test/common-tests.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci.h>
+#       include <soci/backends/mysql/soci-mysql.h>
+#       include <soci/core/test/common-tests.h>
+#else
+#	include <soci.h>
+#	include <soci-mysql.h>
+#       include <test/common-tests.h>
+#endif
+//
 #include <iostream>
 #include <sstream>
 #include <string>
@@ -18,8 +26,14 @@
 #include <ctime>
 #include <ciso646>
 #include <cstdlib>
-#include <mysqld_error.h>
-#include <errmsg.h>
+// MySQL Client
+#if defined(SOCI_MYSQL_HEADERS_BURIED)
+#       include <mysql/mysqld_error.h>
+#       include <mysql/errmsg.h>
+#else
+#       include <mysqld_error.h>
+#       include <errmsg.h>
+#endif
 
 using namespace soci;
 using namespace soci::tests;
diff -Nur --exclude=.svn src/backends/mysql/vector-into-type.cpp soci/backends/mysql/vector-into-type.cpp
--- src/backends/mysql/vector-into-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/vector-into-type.cpp	2009-04-19 15:59:47.000000000 +0200
@@ -9,7 +9,13 @@
 #define SOCI_MYSQL_SOURCE
 #include "soci-mysql.h"
 #include "common.h"
-#include <soci-platform.h>
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-platform.h>
+#else
+#	include <soci-platform.h>
+#endif
+//
 #include <ciso646>
 
 #ifdef _MSC_VER
diff -Nur --exclude=.svn src/backends/mysql/vector-use-type.cpp soci/backends/mysql/vector-use-type.cpp
--- src/backends/mysql/vector-use-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/mysql/vector-use-type.cpp	2009-04-19 16:02:14.000000000 +0200
@@ -9,7 +9,12 @@
 #define SOCI_MYSQL_SOURCE
 #include "soci-mysql.h"
 #include "common.h"
-#include <soci-platform.h>
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-platform.h>
+#else
+#	include <soci-platform.h>
+#endif
 // std
 #include <ciso646>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/odbc/Makefile.am soci/backends/odbc/Makefile.am
--- src/backends/odbc/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/odbc/Makefile.am	2009-04-19 23:54:30.000000000 +0200
@@ -1,41 +1,30 @@
-# $Id: Makefile.am,v 1.2 2008/05/12 13:21:25 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-INCLUDES = -I$(top_srcdir)/src/core
-AM_CXXFLAGS = -fPIC
-AM_CPPFLAGS = @ODBC_CFLAGS@
-
-lib_LTLIBRARIES	= \
-	lib@SOCI_ODBC_LIBRARY_NAME@.la
-
-lib@SOCI_ODBC_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined @ODBC_LDFLAGS@
-
-lib@SOCI_ODBC_LIBRARY_NAME@_la_LIBADD = \
-	@top_builddir@/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la
-
-lib@SOCI_ODBC_LIBRARY_NAME@_la_SOURCES = \
-	blob.cpp \
-	factory.cpp \
-	row-id.cpp \
-	session.cpp \
-	standard-into-type.cpp \
-	standard-use-type.cpp \
-	statement.cpp \
-	vector-into-type.cpp \
-	vector-use-type.cpp
-
-EXTRA_DIST = \
-	Makefile.basic
-
-soci_odbcdir = $(includedir)/soci/odbc
-
-soci_odbc_HEADERS = \
-	utility.h
-	soci-odbc.h
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## backends/odbc sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic makefile.msvc
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+if HAVE_ODBC
+lib_LTLIBRARIES= libsoci_odbc.la
+
+libsoci_odbc_la_SOURCES= $(bck_odbc_h_sources) $(bck_odbc_cc_sources) 
+libsoci_odbc_la_CXXFLAGS = $(ODBC_CFLAGS)
+libsoci_odbc_la_LIBADD =
+libsoci_odbc_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+pkginclude_HEADERS = $(top_srcdir)/soci/backends/odbc/soci-odbc.h
+endif
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/backends/odbc
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/backends/odbc/sources.mk soci/backends/odbc/sources.mk
--- src/backends/odbc/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/odbc/sources.mk	2009-04-19 01:46:00.000000000 +0200
@@ -0,0 +1,13 @@
+bck_odbc_h_sources = \
+        $(top_srcdir)/soci/backends/odbc/utility.h \
+        $(top_srcdir)/soci/backends/odbc/soci-odbc.h
+bck_odbc_cc_sources = \
+        $(top_srcdir)/soci/backends/odbc/blob.cpp \
+        $(top_srcdir)/soci/backends/odbc/factory.cpp \
+        $(top_srcdir)/soci/backends/odbc/row-id.cpp \
+        $(top_srcdir)/soci/backends/odbc/session.cpp \
+        $(top_srcdir)/soci/backends/odbc/standard-into-type.cpp \
+        $(top_srcdir)/soci/backends/odbc/standard-use-type.cpp \
+        $(top_srcdir)/soci/backends/odbc/statement.cpp \
+        $(top_srcdir)/soci/backends/odbc/vector-into-type.cpp \
+        $(top_srcdir)/soci/backends/odbc/vector-use-type.cpp
